"use strict";
Object.defineProperty(exports, "__esModule", { value: !0 });
var coreLoader = require("@sanity/core-loader"), defineUseQuery = require("./_chunks-cjs/defineUseQuery.cjs"), createDataAttribute = require("@sanity/core-loader/create-data-attribute");
const createQueryStore = (options) => {
  const {
    createFetcherStore,
    setServerClient: setServerClient2,
    enableLiveMode,
    unstable__cache,
    unstable__serverClient
  } = coreLoader.createQueryStore({ tag: "react-loader", ...options }), studioUrlStore = defineUseQuery.defineStudioUrlStore(options.client), useQuery2 = defineUseQuery.defineUseQuery({ createFetcherStore, studioUrlStore }), useLiveMode2 = defineUseQuery.defineUseLiveMode({
    enableLiveMode,
    setStudioUrl: studioUrlStore.setStudioUrl
  });
  return {
    loadQuery: async (query, params = {}, options2 = {}) => {
      const { headers, tag } = options2, perspective = options2.perspective || unstable__serverClient.instance?.config().perspective || "published";
      if (typeof document < "u")
        throw new Error(
          "Cannot use `loadQuery` in a browser environment, you should use it inside a loader, getStaticProps, getServerSideProps, getInitialProps, or in a React Server Component."
        );
      if (perspective !== "published" && !unstable__serverClient.instance)
        throw new Error(
          'You cannot use other perspectives than "published" unless you set "ssr: true" and call "setServerClient" first.'
        );
      if (perspective === "previewDrafts") {
        if (!unstable__serverClient.canPreviewDrafts)
          throw new Error(
            `You cannot use "previewDrafts" unless you set a "token" in the "client" instance you're pasing to "setServerClient".`
          );
        const { result: result2, resultSourceMap: resultSourceMap2 } = await unstable__serverClient.instance.fetch(query, params, {
          filterResponse: !1,
          resultSourceMap: "withKeyArraySelector",
          perspective,
          useCdn: !1,
          headers,
          tag
        });
        return resultSourceMap2 ? { data: result2, sourceMap: resultSourceMap2, perspective } : { data: result2, perspective };
      }
      const { result, resultSourceMap } = await unstable__cache.instance.fetch(
        JSON.stringify({ query, params })
      );
      return resultSourceMap ? { data: result, sourceMap: resultSourceMap } : { data: result };
    },
    // @ts-expect-error - update typings
    useQuery: useQuery2,
    setServerClient: setServerClient2,
    useLiveMode: useLiveMode2
  };
}, { loadQuery, setServerClient, useLiveMode, useQuery } = createQueryStore({
  client: !1,
  ssr: !0
});
exports.useEncodeDataAttribute = defineUseQuery.useEncodeDataAttribute;
exports.createQueryStore = createQueryStore;
exports.loadQuery = loadQuery;
exports.setServerClient = setServerClient;
exports.useLiveMode = useLiveMode;
exports.useQuery = useQuery;
Object.keys(createDataAttribute).forEach(function(k) {
  k !== "default" && !Object.prototype.hasOwnProperty.call(exports, k) && Object.defineProperty(exports, k, {
    enumerable: !0,
    get: function() {
      return createDataAttribute[k];
    }
  });
});
//# sourceMappingURL=index.cjs.map
